#include <iostream>
using namespace std;

int MAX_LEN = 100;

struct Contact
{
	char sex;
	int height;
	int weight; 
	int score; 
	void print()
	{
		cout << "(" << sex << ", " << height << ", " << weight << ")" << endl;
	}
};

// used only for debugging
void print(Contact ctBook[], int ctCount)
{
	cout << "=========" << endl;
	for (int i = 0; i < ctCount; i++)
		ctBook[i].print();
	cout << "=========" << endl;
}

int main()
{
	Contact ctBook[MAX_LEN];
	for (int i = 0; i < MAX_LEN; i++)
		ctBook[i] = {' ', 0, 0};
	int ctCount = 0;
	
	char instruction = ' ';
	while (cin >> instruction)
	{
		if (instruction == 'I')
		{
			Contact cur = {' ', 0, 0};
			cin >> cur.sex >> cur.height >> cur.weight; 
			if (cur.sex == 'F')
				cur.score = cur.height * 1000 + cur.weight; 
			else
				cur.score = 1000000 + cur.height * 1000 + cur.weight; 
				
			bool hasInserted = false;
			for (int i = ctCount - 1; i >= 0; i--)
			{
				if (ctBook[i].score <= cur.score)
				{
					ctBook[i + 1] = cur; 
					hasInserted = true;
					break;
				}
				else
					ctBook[i + 1] = ctBook[i]; 
			}
			if (hasInserted == false)
				ctBook[0] = cur;
			ctCount++;

			// used only for debugging
			// print(ctBook, ctCount);
		}
		else if (instruction == 'L')
		{
			int toLookUp = 0;
			cin >> toLookUp;
			ctBook[toLookUp - 1].print();
		}
		else if (instruction == 'S')
		{
			char toCount = ' ';
			cin >> toCount; 

			if (toCount == 'S')
			{
				char sexToCount = ' ';
				cin >> sexToCount;
				int fitCount = 0;
				
				for (int i = 0; i < ctCount; i++)
				{
					if (ctBook[i].sex == sexToCount)
						fitCount++;
				}

				cout << fitCount << endl;
			}
			else if (toCount == 'H')
			{
				int heightToCount = 0;
				cin >> heightToCount;
				int fitCount = 0;
				
				for (int i = 0; i < ctCount; i++)
				{
					if (ctBook[i].height >= heightToCount)
						fitCount++;
				}
				
				cout << fitCount << endl;
			}
			else if (toCount == 'W')
			{
				int weightToCount = 0;
				cin >> weightToCount;
				int fitCount = 0;
				
				for (int i = 0; i < ctCount; i++)
				{
					if (ctBook[i].weight >= weightToCount)
						fitCount++;
				}
				
				cout << fitCount << endl;
			}			
		}
	}	
	
	return 0;
}
